Subject: RE: Asinine anti-spam mechanisms

From: "Larry Osterman (Exchange)" <[email-masked]>
Date: Mon, 7 Jun 1999 15:15:42 -0700

It was a stupid coding error - the guys who wrote the SMTP service shipped
in the NT4 option pack used an invalid handle value during a call to an NT
API that was supposed to wait until either a timeout occurred or when the
SMTP service was shut down.

There were actually 2 different bugs which conspired to cause the problem:
	1) The invalid handle in the first place
and	2) The fact that instead of checking for the explicit ERROR_TIMEOUT
error, they decided that ANY error value was caused by a timeout.

There was no INTENTION to violate 1123, it was just a plain and simple screw
up.  And we managed to screw it up because we're human beings and we didn't
have a test case for this particular situation.  And as Dick commented below
- we had a fix available within days of when it was reported (and the fix is
contained in NT4 SP5, which has been on the web for at least a month now).
But it does take time for fixes to be propogated, that's the way life works.

Larry Osterman
Sent from larryo-laptop.dns.microsoft.com running NT5 and Outlook 2000
and Exchange Server 5.5.  Please notify the sender of any difficulties

> -----Original Message-----
> From: D. J. Bernstein [mailto:[email-masked]]
> Sent: Monday, June 07, 1999 2:35 PM
> To: [email-masked]
> Cc: [email-masked]
> Subject: Re: Asinine anti-spam mechanisms
> 
> 
> Dick St.Peters writes:
> > If the remote client is an NT server running Microsoft SMTP 
> without an
> > update Microsoft issued in March, it will try again 
> immediately if you
> > send it a 4xx code.
> 
> As if common sense weren't enough: RFC 1123 specifically requires that
> SMTP clients delay before trying again. I wonder how Microsoft managed
> to screw this up.
> 
> Anyway, this doesn't justify Keith's asinine ``put the message on hold
> and wait for human intervention'' method of handling 
> temporary failures.
> If Keith has a problem with a Microsoft host, then he can deal with it
> without setting up a fragile mail system that screws up other people's
> messages.
> 
> ---Dan
>

---

From: "Larry Osterman (Exchange)" <[email-masked]>
Date: Mon, 7 Jun 1999 15:15:42 -0700

Larry Osterman